﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Client
{
    class BarcodeTSC
    {
        [DllImport("TSCLIB.dll", EntryPoint = "about")]
        public static extern int about();

        [DllImport("TSCLIB.dll", EntryPoint = "openport")]
        public static extern int openport(string printername);

        //readable : 0: no text 1: text
        //type  [1D barcode]:
        //        Code 39, Code 93, Code 128UCC,
        //Code 128 subset A, B, C, Codabar,
        //Interleave 2 of 5, EAN-8, EAN-13,
        //EAN-128, UPC-A, UPC-E, EAN and
        //UPC 2 (5) digits add-on, MSI,
        //PLESSEY, POSTNET, RSSStacked,
        //GS1 DataBar, Code 11
        // [2D barCode]
        //        DataMatrix,
        //Maxicode, PDF-417,
        //Aztec, QR code
        [DllImport("TSCLIB.dll", EntryPoint = "barcode")]
        public static extern int barcode(string x, string y, string type, string height, string readable, string rotation,
            string narrow, string wide, string code);

        [DllImport("TSCLIB.dll", EntryPoint = "clearbuffer")]
        public static extern int clearbuffer();

        [DllImport("TSCLIB.dll", EntryPoint = "closeport")]
        public static extern int closeport();

        [DllImport("TSCLIB.dll", EntryPoint = "downloadpcx")]
        public static extern int downloadpcx(string filename, string image_name);

        [DllImport("TSCLIB.dll", EntryPoint = "formfeed")]
        public static extern int formfeed();

        [DllImport("TSCLIB.dll", EntryPoint = "nobackfeed")]
        public static extern int nobackfeed();

        //fonttype : 1: 8*12 dots ,2: 12*20 dots ,3:16*24 dots ,4:24*32 dots , 5:32*48 dots , K:japan,Korean font 24*24 , L:japan Korean font 16*16
        //xmul : 1~8
        //ymul : 1~8
        [DllImport("TSCLIB.dll", EntryPoint = "printerfont")]
        public static extern int printerfont(string x, string y, string fonttype, string rotation, string xmul, string ymul, string text);

        [DllImport("TSCLIB.dll", EntryPoint = "printlabel")]
        public static extern int printlabel(string set, string copy);

        [DllImport("TSCLIB.dll", EntryPoint = "sendcommand")]
        public static extern int sendcommand(string printercommand);

        //width : mm
        //height :mm
        //density : 큰숫자일수록 진함 0~15
        //sensor : 0 : vertical gap sensor 1:black mark sensor
        //vertical : vertical gap height of the gap/black mark : mm
        //offset : shift distance of the gap/black mark : mm 
        [DllImport("TSCLIB.dll", EntryPoint = "setup")]
        public static extern int setup(string width, string height, string speed, string density, string sensor, string vertical, string offset);

        //fontstyle : 0:normal, 1:italic , 2:Bold , 3: Bold and Italic
        //fontunderline : 0:without underline 1:with underline
        [DllImport("TSCLIB.dll", EntryPoint = "windowsfont")]
        public static extern int windowsfont(int x, int y, int fontheight, int rotation, int fontstyle, int fontunderline,
            string szFaceName, string content);

    }
}
